import { computed as h, ref as i, watch as Ie, onMounted as Me, onBeforeUnmount as De, openBlock as o, createElementBlock as u, normalizeClass as F, normalizeStyle as Q, createBlock as T, createCommentVNode as c, unref as d, createSlots as Ge, withCtx as f, renderSlot as y, normalizeProps as W, guardReactiveProps as I, createVNode as xe, Fragment as g, renderList as C, createElementVNode as k, toDisplayString as L, mergeProps as Ee, createTextVNode as Ve, nextTick as He } from "vue";
import { u as Re, c as Z, t as Ue, a as Be, p as A, o as Xe, e as ee, g as Ce, b as je, d as we, v as Ye, D as Je, f as B, X as qe, i as te, l as Ke, h as Qe, x as _e, y as Ze, q as et, r as tt, F as lt } from "./index-Cm2_6s9o.js";
import { t as at, u as ot } from "./useResponsive-CoxXLe23.js";
import { _ as st } from "./Title-Coit3NcT.js";
import { u as rt, U as ut } from "./usePrinter-Cx8U1e30.js";
import { _ as nt } from "./Tooltip-BBgfUr4a.js";
import { D as it } from "./DataTable-NGi-FgLM.js";
import ct from "./vue-ui-skeleton-BUS6A44x.js";
import { _ as vt } from "./Shape-C-sY_hlc.js";
import ht from "./vue-ui-accordion-CxrNF8BI.js";
import { u as $e } from "./useNestedProp-BYPZJNhi.js";
import { _ as dt } from "./PackageVersion-CTMY4zeY.js";
import { P as pt } from "./PenAndPaper-DJ_d10S-.js";
import { _ as ft } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const yt = ["id"], bt = ["xmlns", "viewBox"], mt = { key: 0 }, gt = { key: 0 }, kt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], xt = { key: 1 }, Ct = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], wt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], _t = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], $t = ["x", "y", "fill", "font-size"], Tt = ["x", "y", "font-size", "fill"], Lt = ["fill", "font-size", "transform"], At = ["fill", "font-size", "x", "y"], Pt = ["x1", "x2", "y1", "y2", "stroke"], St = ["cx", "cy", "fill"], zt = ["cx", "cy", "fill"], Nt = ["id"], Ot = ["stop-color"], Ft = ["stop-color"], Wt = ["stop-color"], It = { key: 0 }, Mt = ["x", "y", "font-size", "fill"], Dt = {
  key: 5,
  class: "vue-data-ui-watermark"
}, Gt = ["innerHTML"], Et = {
  __name: "vue-ui-strip-plot",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectDatapoint"],
  setup(Te, { expose: Le, emit: Ae }) {
    const b = Te, { vue_ui_strip_plot: Pe } = Re(), w = h({
      get() {
        return !!b.dataset && b.dataset.length;
      },
      set(t) {
        return t;
      }
    }), X = i(Z()), le = i(0), j = i(!1), Y = i(""), P = i(null), ae = i(null), oe = i(null), se = i(null), re = i(!1), ue = i(0), ne = i(0), e = h({
      get: () => ie(),
      set: (t) => t
    });
    function ie() {
      const t = $e({
        userConfig: b.config,
        defaultConfig: Pe
      });
      return t.theme ? {
        ...$e({
          userConfig: Ue.vue_ui_strip_plot[t.theme] || b.config,
          defaultConfig: t
        }),
        customPalette: Be[t.theme] || A
      } : t;
    }
    Ie(() => b.config, (t) => {
      e.value = ie(), ce(), ue.value += 1, ne.value += 1;
    }, { deep: !0 });
    const M = i(null);
    Me(() => {
      ce();
    });
    function ce() {
      if (Xe(b.dataset) ? ee({
        componentName: "VueUiStripPlot",
        type: "dataset"
      }) : b.dataset.forEach((t, s) => {
        Ce({
          datasetObject: t,
          requiredAttributes: ["name", "plots"]
        }).forEach((l) => {
          w.value = !1, ee({
            componentName: "VueUiStripPlot",
            type: "datasetSerieAttribute",
            property: l,
            index: s
          });
        }), t.plots && t.plots.forEach((l, r) => {
          Ce({
            datasetObject: l,
            requiredAttributes: ["name", "value"]
          }).forEach((n) => {
            w.value = !1, ee({
              componentName: "VueUiStripPlot",
              type: "datasetSerieAttribute",
              property: n,
              index: `${s},${r}`
            });
          });
        });
      }), e.value.responsive) {
        const t = at(() => {
          const { width: s, height: l } = ot({
            chart: P.value,
            title: e.value.style.chart.title.text ? ae.value : null,
            source: oe.value,
            noTitle: se.value
          });
          D.value = l, S.value.width = s, S.value.height = l, O.value = (s - m.value.left - m.value.right) / b.dataset.length, G.value = lt({
            relator: Math.min(l, s),
            adjuster: 600,
            source: e.value.style.chart.plots.radius,
            threshold: 6,
            fallback: 6
          });
        });
        M.value = new ResizeObserver(t), M.value.observe(P.value.parentNode);
      }
      re.value = !0, setTimeout(() => {
        N.value = !1;
      }, ze.value * 50);
    }
    De(() => {
      M.value && M.value.disconnect();
    });
    const { isPrinting: ve, isImaging: he, generatePdf: de, generateImage: pe } = rt({
      elementId: `strip-plot_${X.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-strip-plot"
    }), Se = h(() => e.value.userOptions.show && !e.value.style.chart.title.text), fe = h(() => je(e.value.customPalette)), N = i(e.value.useCssAnimation), p = i({
      showTable: e.value.table.show,
      dataLabels: {
        show: e.value.style.chart.labels.bestPlotLabel.show
      },
      showTooltip: e.value.style.chart.tooltip.show
    }), m = i({
      top: e.value.style.chart.padding.top,
      bottom: e.value.style.chart.padding.bottom,
      left: e.value.style.chart.padding.left,
      right: e.value.style.chart.padding.right
    }), O = i(e.value.style.chart.stripWidth), D = i(e.value.style.chart.height), G = i(e.value.style.chart.plots.radius), S = i({
      width: O.value * b.dataset.length + m.value.left + m.value.right,
      height: e.value.style.chart.height
    }), a = h(() => {
      const t = O.value * b.dataset.length + m.value.left + m.value.right;
      return {
        left: m.value.left,
        right: t - m.value.right,
        top: m.value.top,
        bottom: D.value - m.value.bottom,
        width: O.value * b.dataset.length,
        height: D.value - m.value.top - m.value.bottom,
        stripWidth: O.value,
        absoluteHeight: D.value,
        absoluteWidth: t
      };
    }), E = h(() => w.value ? b.dataset.map((t, s) => {
      const l = Z();
      return {
        ...t,
        id: l,
        color: t.color ? we(t.color) : fe.value[s] || A[s] || A[s % A.length],
        plots: t.plots.map((r) => ({
          ...r,
          value: Ye(r.value),
          parentId: l,
          color: t.color ? we(t.color) : fe.value[s] || A[s] || A[s % A.length],
          id: Z()
        })).sort((r, n) => r.value - n.value)
      };
    }) : null), x = h(() => (E.value || []).map((t, s) => ({
      ...t,
      plots: t.plots.map((l) => ({
        ...l,
        x: a.value.left + (s + 1) * a.value.stripWidth - a.value.stripWidth / 2
      }))
    }))), ze = h(() => Math.max(...x.value.map((t) => t.plots.length))), J = h(() => {
      const t = x.value.flatMap((s) => s.plots.map((l) => l.value));
      return {
        max: Math.max(...t),
        min: Math.min(...t)
      };
    }), _ = h(() => Je(J.value.min < 0 ? J.value.min : 0, J.value.max, e.value.style.chart.grid.scaleSteps)), Ne = h(() => (x.value || []).map((t, s) => ({
      ...t,
      plots: t.plots.map((l) => ({
        ...l,
        y: a.value.bottom - (l.value + Math.abs(_.value.min)) / (_.value.max + Math.abs(_.value.min)) * a.value.height
      }))
    }))), ye = h(() => _.value.ticks.map((t) => ({
      y: a.value.bottom - a.value.height * ((t + Math.abs(_.value.min)) / (_.value.max + Math.abs(_.value.min))),
      x1: a.value.left,
      x2: a.value.right,
      value: t
    }))), q = i(null), v = i(null);
    function Oe({ datapoint: t, seriesIndex: s }) {
      q.value = { datapoint: t, seriesIndex: s, config: e.value, series: E.value }, j.value = !0, v.value = t;
      const l = e.value.style.chart.tooltip.customFormat;
      if (_e(l) && Ze(() => l({
        seriesIndex: s,
        datapoint: t,
        series: E.value,
        config: e.value
      })))
        Y.value = l({
          seriesIndex: s,
          datapoint: t,
          series: E.value,
          config: e.value
        });
      else {
        let r = "";
        r += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${e.value.style.chart.plots.gradient.show ? `url(#${t.parentId})` : t.color}"/></svg>${t.name}</div>`, r += `<div>${te(
          e.value.style.chart.labels.formatter,
          t.value,
          B({
            p: e.value.style.chart.labels.prefix,
            v: t.value,
            s: e.value.style.chart.labels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          { datapoint: t, seriesIndex: s }
        )}</div>`, Y.value = `<div>${r}</div>`;
      }
    }
    const V = h(() => {
      const t = x.value.flatMap((l) => JSON.parse(JSON.stringify(l.plots)).sort((r, n) => n.value - r.value).map((r) => ({
        name: `${l.name} - ${r.name}`,
        color: r.color
      }))), s = x.value.flatMap((l) => JSON.parse(JSON.stringify(l.plots)).sort((r, n) => n.value - r.value).map((r) => r.value));
      return { head: t, body: s };
    });
    function be() {
      He(() => {
        const t = V.value.head.map((r, n) => [[
          r.name
        ], [V.value.body[n]]]), s = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[e.value.table.columnNames.series], [e.value.table.columnNames.value]]].concat(t), l = et(s);
        tt({ csvContent: l, title: e.value.style.chart.title.text || "vue-ui-strip-plot" });
      });
    }
    const H = h(() => {
      const t = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value
      ], s = V.value.head.map((n, $) => {
        const U = B({
          p: e.value.style.chart.labels.prefix,
          v: V.value.body[$],
          s: e.value.style.chart.labels.suffix,
          r: e.value.table.td.roundingValue
        });
        return [
          {
            color: n.color,
            name: n.name
          },
          U
        ];
      }), l = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value
        ],
        head: t,
        body: s,
        config: l
      };
    }), z = i(!1);
    function Fe(t) {
      z.value = t, le.value += 1;
    }
    function We() {
      return x.value;
    }
    function me() {
      p.value.showTable = !p.value.showTable;
    }
    function ge() {
      p.value.dataLabels.show = !p.value.dataLabels.show;
    }
    function ke() {
      p.value.showTooltip = !p.value.showTooltip;
    }
    const R = i(!1);
    function K() {
      R.value = !R.value;
    }
    return Le({
      getData: We,
      generatePdf: de,
      generateCsv: be,
      generateImage: pe,
      toggleTable: me,
      toggleLabels: ge,
      toggleTooltip: ke,
      toggleAnnotator: K
    }), (t, s) => (o(), u("div", {
      ref_key: "stripPlotChart",
      ref: P,
      class: F(`vue-ui-strip-plot ${z.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: Q(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height:100%" : ""}`),
      id: `strip-plot_${X.value}`
    }, [
      e.value.userOptions.buttons.annotator ? (o(), T(pt, {
        key: 0,
        parent: P.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: R.value,
        onClose: K
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : c("", !0),
      Se.value ? (o(), u("div", {
        key: 1,
        ref_key: "noTitle",
        ref: se,
        class: "vue-data-ui-no-title-space",
        style: "height:36px; width: 100%;background:transparent"
      }, null, 512)) : c("", !0),
      e.value.style.chart.title.text ? (o(), u("div", {
        key: 2,
        ref_key: "chartTitle",
        ref: ae,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (o(), T(st, {
          key: `title_${ue.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : c("", !0),
      e.value.userOptions.show && w.value ? (o(), T(ut, {
        ref: "details",
        key: `user_option_${le.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: d(ve),
        isImaging: d(he),
        uid: X.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isTooltip: p.value.showTooltip,
        isFullscreen: z.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: P.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: R.value,
        onToggleFullscreen: Fe,
        onGeneratePdf: d(de),
        onGenerateCsv: be,
        onGenerateImage: d(pe),
        onToggleTable: me,
        onToggleLabels: ge,
        onToggleTooltip: ke,
        onToggleAnnotator: K
      }, Ge({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: f(() => [
            y(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: f(() => [
            y(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: f(() => [
            y(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: f(() => [
            y(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: f(() => [
            y(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionLabels ? {
          name: "optionLabels",
          fn: f(() => [
            y(t.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: f(({ toggleFullscreen: l, isFullscreen: r }) => [
            y(t.$slots, "optionFullscreen", W(I({ toggleFullscreen: l, isFullscreen: r })), void 0, !0)
          ]),
          key: "6"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: f(({ toggleAnnotator: l, isAnnotator: r }) => [
            y(t.$slots, "optionAnnotator", W(I({ toggleAnnotator: l, isAnnotator: r })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasLabel", "hasFullscreen", "isTooltip", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : c("", !0),
      w.value ? (o(), u("svg", {
        key: 4,
        xmlns: d(qe),
        class: F({ "vue-data-ui-fullscreen--on": z.value, "vue-data-ui-fulscreen--off": !z.value }),
        viewBox: `0 0 ${S.value.width <= 0 ? 10 : S.value.width} ${S.value.height <= 0 ? 10 : S.value.height}`,
        style: Q(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color};`)
      }, [
        xe(dt),
        e.value.style.chart.grid.show ? (o(), u("g", mt, [
          e.value.style.chart.grid.horizontalGrid.show ? (o(), u("g", gt, [
            (o(!0), u(g, null, C(ye.value, (l) => (o(), u("line", {
              x1: l.x1,
              x2: l.x2,
              y1: l.y,
              y2: l.y,
              stroke: e.value.style.chart.grid.horizontalGrid.stroke,
              "stroke-width": e.value.style.chart.grid.horizontalGrid.strokeWidth,
              "stroke-dasharray": e.value.style.chart.grid.horizontalGrid.strokeDasharray,
              "stroke-linecap": "round"
            }, null, 8, kt))), 256))
          ])) : c("", !0),
          e.value.style.chart.grid.verticalGrid.show ? (o(), u("g", xt, [
            (o(!0), u(g, null, C(x.value, (l, r) => (o(), u("line", {
              x1: a.value.left + (r + 1) * a.value.stripWidth,
              x2: a.value.left + (r + 1) * a.value.stripWidth,
              y1: a.value.top,
              y2: a.value.bottom,
              stroke: e.value.style.chart.grid.verticalGrid.stroke,
              "stroke-width": e.value.style.chart.grid.verticalGrid.strokeWidth,
              "stroke-dasharray": e.value.style.chart.grid.verticalGrid.strokeDasharray,
              "stroke-linecap": "round"
            }, null, 8, Ct))), 256))
          ])) : c("", !0),
          k("line", {
            x1: a.value.left,
            x2: a.value.left,
            y1: a.value.top,
            y2: a.value.bottom,
            stroke: e.value.style.chart.grid.stroke,
            "stroke-width": e.value.style.chart.grid.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, wt),
          k("line", {
            x1: a.value.left,
            x2: a.value.right,
            y1: a.value.bottom,
            y2: a.value.bottom,
            stroke: e.value.style.chart.grid.stroke,
            "stroke-width": e.value.style.chart.grid.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, _t)
        ])) : c("", !0),
        e.value.style.chart.labels.yAxisLabels.show ? (o(!0), u(g, { key: 1 }, C(ye.value, (l, r) => (o(), u("text", {
          x: l.x1 - e.value.style.chart.labels.yAxisLabels.fontSize / 2 + e.value.style.chart.labels.yAxisLabels.offsetX,
          y: l.y + e.value.style.chart.labels.yAxisLabels.fontSize / 3,
          fill: e.value.style.chart.labels.yAxisLabels.color,
          "font-size": e.value.style.chart.labels.yAxisLabels.fontSize,
          "text-anchor": "end"
        }, L(d(te)(
          e.value.style.chart.labels.formatter,
          l.value,
          d(B)({
            p: e.value.style.chart.labels.prefix,
            v: l.value,
            s: e.value.style.chart.labels.suffix,
            r: e.value.style.chart.labels.yAxisLabels.rounding
          }),
          { datapoint: l, seriesIndex: r }
        )), 9, $t))), 256)) : c("", !0),
        e.value.style.chart.labels.xAxisLabels.show ? (o(!0), u(g, { key: 2 }, C(x.value, (l, r) => (o(), u("text", {
          x: a.value.left + (r + 1) * a.value.stripWidth - a.value.stripWidth / 2,
          y: a.value.bottom + e.value.style.chart.labels.xAxisLabels.fontSize * 2 + e.value.style.chart.labels.xAxisLabels.offsetY,
          "font-size": e.value.style.chart.labels.xAxisLabels.fontSize,
          fill: e.value.style.chart.labels.xAxisLabels.color,
          "text-anchor": "middle"
        }, L(l.name), 9, Tt))), 256)) : c("", !0),
        e.value.style.chart.labels.axis.yLabel ? (o(), u("text", {
          key: 3,
          fill: e.value.style.chart.labels.axis.color,
          "font-size": e.value.style.chart.labels.axis.fontSize,
          transform: `translate(${e.value.style.chart.labels.axis.fontSize + e.value.style.chart.labels.axis.yLabelOffsetX}, ${a.value.top + a.value.height / 2}) rotate(-90)`,
          "text-anchor": "middle"
        }, L(e.value.style.chart.labels.axis.yLabel), 9, Lt)) : c("", !0),
        e.value.style.chart.labels.axis.xLabel ? (o(), u("text", {
          key: 4,
          fill: e.value.style.chart.labels.axis.color,
          "font-size": e.value.style.chart.labels.axis.fontSize,
          x: a.value.left + a.value.width / 2,
          y: a.value.absoluteHeight,
          "text-anchor": "middle"
        }, L(e.value.style.chart.labels.axis.xLabel), 9, At)) : c("", !0),
        v.value ? (o(), u(g, { key: 5 }, [
          k("line", {
            x1: a.value.left,
            x2: a.value.right,
            y1: v.value.y,
            y2: v.value.y,
            stroke: v.value.color,
            "stroke-width": 1,
            class: F({ "select-circle": e.value.useCssAnimation })
          }, null, 10, Pt),
          k("circle", {
            cx: a.value.left,
            cy: v.value.y,
            r: 3,
            fill: v.value.color,
            class: F({ "select-circle": e.value.useCssAnimation })
          }, null, 10, St),
          k("circle", {
            cx: a.value.right,
            cy: v.value.y,
            r: 3,
            fill: v.value.color,
            class: F({ "select-circle": e.value.useCssAnimation })
          }, null, 10, zt)
        ], 64)) : c("", !0),
        k("defs", null, [
          (o(!0), u(g, null, C(x.value, (l) => (o(), u("radialGradient", {
            id: l.id,
            fy: "30%"
          }, [
            k("stop", {
              offset: "10%",
              "stop-color": d(Ke)(l.color, e.value.style.chart.plots.gradient.intensity / 100)
            }, null, 8, Ot),
            k("stop", {
              offset: "90%",
              "stop-color": d(Qe)(l.color, 0.1)
            }, null, 8, Ft),
            k("stop", {
              offset: "100%",
              "stop-color": l.color
            }, null, 8, Wt)
          ], 8, Nt))), 256))
        ]),
        (o(!0), u(g, null, C(Ne.value, (l, r) => (o(), u(g, null, [
          (o(!0), u(g, null, C(l.plots, (n, $) => (o(), T(vt, Ee({
            plot: { x: n.x, y: re.value ? n.y : a.value.top },
            radius: v.value && v.value.id === n.id ? G.value * 1.5 : G.value,
            shape: e.value.style.chart.plots.shape,
            stroke: e.value.style.chart.plots.stroke,
            strokeWidth: e.value.style.chart.plots.strokeWidth,
            color: e.value.style.chart.plots.gradient.show ? `url(#${l.id})` : l.color,
            onMouseenter: (U) => Oe({ datapoint: n, seriesIndex: $ }),
            onMouseleave: s[0] || (s[0] = (U) => {
              j.value = !1, v.value = null;
            }),
            onClick: (U) => Ae("selectDatapoint", n),
            style: `transition: all 0.2s ease-in-out; opacity:${v.value ? v.value.id === n.id ? 1 : 0.2 : e.value.style.chart.plots.opacity};${N.value ? `transition-delay:${$ * 50}ms` : ""}`,
            class: { "vue-ui-strip-plot-animated": e.value.useCssAnimation && N.value, "vue-ui-strip-plot-select-circle": e.value.useCssAnimation && !N.value }
          }, t.$attrs), null, 16, ["plot", "radius", "shape", "stroke", "strokeWidth", "color", "onMouseenter", "onClick", "style", "class"]))), 256)),
          p.value.dataLabels.show ? (o(), u("g", It, [
            (o(!0), u(g, null, C(l.plots, (n, $) => (o(), u(g, null, [
              $ === l.plots.length - 1 || v.value && v.value.id === n.id && !p.value.showTooltip ? (o(), u("text", {
                key: 0,
                x: n.x,
                y: n.y + e.value.style.chart.labels.bestPlotLabel.offsetY - G.value * (v.value && v.value.id === n.id && !p.value.showTooltip ? 2 : 1.5),
                "font-size": e.value.style.chart.labels.bestPlotLabel.fontSize,
                fill: e.value.style.chart.labels.bestPlotLabel.color,
                "text-anchor": "middle",
                style: Q(`opacity:${e.value.useCssAnimation && N.value ? 0 : 1};transition:opacity 0.2s ease-in;`)
              }, L(n.name) + " " + L(e.value.style.chart.labels.bestPlotLabel.showValue ? d(te)(
                e.value.style.chart.labels.formatter,
                n.value,
                d(B)({
                  p: `(${e.value.style.chart.labels.prefix}`,
                  v: n.value,
                  s: `${e.value.style.chart.labels.suffix})`,
                  r: e.value.style.chart.labels.bestPlotLabel.rounding
                }),
                { datapoint: n, seriesIndex: $ }
              ) : ""), 13, Mt)) : c("", !0)
            ], 64))), 256))
          ])) : c("", !0)
        ], 64))), 256)),
        y(t.$slots, "svg", { svg: a.value }, void 0, !0)
      ], 14, bt)) : c("", !0),
      t.$slots.watermark ? (o(), u("div", Dt, [
        y(t.$slots, "watermark", W(I({ isPrinting: d(ve) || d(he) })), void 0, !0)
      ])) : c("", !0),
      w.value ? c("", !0) : (o(), T(ct, {
        key: 6,
        config: {
          type: "stripPlot",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            stripPlot: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      t.$slots.source ? (o(), u("div", {
        key: 7,
        ref_key: "source",
        ref: oe,
        dir: "auto"
      }, [
        y(t.$slots, "source", {}, void 0, !0)
      ], 512)) : c("", !0),
      xe(nt, {
        show: p.value.showTooltip && j.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        fontSize: e.value.style.chart.tooltip.fontSize,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: P.value,
        content: Y.value,
        isFullscreen: z.value,
        isCustom: d(_e)(e.value.style.chart.tooltip.customFormat)
      }, {
        "tooltip-before": f(() => [
          y(t.$slots, "tooltip-before", W(I({ ...q.value })), void 0, !0)
        ]),
        "tooltip-after": f(() => [
          y(t.$slots, "tooltip-after", W(I({ ...q.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isFullscreen", "isCustom"]),
      w.value ? (o(), T(ht, {
        key: 8,
        hideDetails: "",
        config: {
          open: p.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: f(() => [
          (o(), T(it, {
            key: `table_${ne.value}`,
            colNames: H.value.colNames,
            head: H.value.head,
            body: H.value.body,
            config: H.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: s[1] || (s[1] = (l) => p.value.showTable = !1)
          }, {
            th: f(({ th: l }) => [
              k("div", {
                innerHTML: l,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, Gt)
            ]),
            td: f(({ td: l }) => [
              Ve(L(l.name || l), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : c("", !0)
    ], 14, yt));
  }
}, tl = /* @__PURE__ */ ft(Et, [["__scopeId", "data-v-8cbdee95"]]);
export {
  tl as default
};
